package momoko.compiler;

import java.util.Enumeration;
import java.io.*;
import momoko.*;
import momoko.protoclass.*;
import momoko.versioncontrol.*;

/**
 *  ProtoClass to Java class compiler
 */
abstract public class Compiler
{
  protected Runtime rt=Runtime.getRuntime();
  protected String classname;


abstract public File createfile(IProtoClass pc) throws IOException;

abstract protected void preprocess(String name) throws InterruptedException, IOException;

abstract protected void process(String name) throws InterruptedException, IOException;

abstract protected void cleanup(String name) throws InterruptedException, IOException;

protected void postprocess(IProtoClass pc) throws InterruptedException, IOException
  {
    Process proc;
    String name=pc.name();

    System.out.println("Postprocessing...");
    cleanup(name);
    System.out.println("Cleanup subprocess finished.");
    Database.types.add(name);
    VersionController vc=pc.getController();
    System.out.println("Time to migrate.");
    vc.migrate();
    System.out.println("Done.");
  }


  public String compile(IProtoClass pc)
  {
    System.out.println("Actualling in compile. "+this);
    try
    {
      if(pc==null) return "";
      classname=pc.name();
      createfile(pc);
      preprocess(pc.name());
      process(pc.name());
      postprocess(pc);
    }
    catch(Exception e)
    {
      System.out.println("Compilation error:\n"+e);
      e.printStackTrace();
    }
    finally { return ""; }
  }

abstract protected String print(Property prop);
}
