package momoko.compiler;

import momoko.*;
import momoko.util.*;
import momoko.protoclass.*;
import momoko.versioncontrol.*;
import java.util.*;
import java.io.*;

/**
 * 
 */
public class InterfaceCompiler extends JavaCompiler
{

public InterfaceCompiler()
{
  super();
  file_extension=".java";
}

protected void postprocess(ProtoClass pc) throws InterruptedException, IOException
  {
    Process proc;
    String name="I"+pc.name();

    System.out.println("Postprocessing...");
    cleanup(name);
    System.out.println("Cleanup subprocess finished.");
    Database.types.add(name);
    VersionController vc=pc.getController();
    System.out.println("Time to migrate.");
    vc.migrate();
    System.out.println("Done.");
  }

  public String compile(ProtoClass pc)
  {
    System.out.println("Actualling in compile. "+this);
    try
    {
      if(pc==null) return "";
      classname="I"+pc.name();
      createfile(pc);
      preprocess(classname);
      process(classname);
      postprocess(pc);
    }
    catch(Exception e)
    {
      System.out.println("Compilation error:\n"+e);
      e.printStackTrace();
    }
    finally { return ""; }
  }

protected void createfile(ProtoClass class_to_compile) throws IOException
{
      pc=class_to_compile;
      System.out.println("Creating file\n");
      if(pc==null) System.out.println("pc is null!");
      out=new PrintWriter(new FileWriter("I"+pc.name()+file_extension));
System.out.println(out);

      ProtoClass parent=(ProtoClass)Database.main.parent.subject(pc);
      if(parent==null) throw new IOException("No parent");

      Vector libs=new Vector();
      libs.addElement(new Pair("java.util", "*"));
      libs.addElement(new Pair("mud.shared.types","MudArray"));

      set_scope("mud.user");
      import_libraries(libs);
      class_header(pc.name(), parent.name());
      access_methods(pc.getproperties());
      other_methods(pc.getproperties());
      class_footer();
      out.close();
}

public void set_scope(String pkg)
{
      out.println("package "+pkg+";");
}

public void import_library(String base, String thing)
{
  out.println("import "+base+"."+thing+";");
}

public void class_header(String classname, String parent)
{
      out.print("public interface I"+classname+" extends I"+parent);
      out.println("{");
}

public void method_header(String name, String returntype, Vector args)
{
        out.print("public "+Database.main.types.classname(returntype)+" "+name+"(");
        Enumeration it=args.elements();
        if(it.hasMoreElements())
        {
          p=(Pair)it.nextElement();
          out.print(Database.main.types.classname((String)p.first)+" "+p.second);
        }
        while(it.hasMoreElements())
        {
          p=(Pair)it.nextElement();
          out.print(", "+Database.main.types.classname((String)p.first)+" "+p.second);
        }
        out.println(");");
}

public void return_statement(String to_return)
{
}

public void assignment_statement(String to, String from)
{
}

public void method_footer()
{
}

public void class_footer()
{
  out.println("}");
}

}
