package momoko.compiler;

import momoko.*;
import momoko.protoclass.*;
import momoko.versioncontrol.*;
import java.util.*;
import momoko.types.*;
import java.io.*;
import java.lang.String;

/**
 * 
 */
abstract public class OOSourceWriter extends SourceWriter
{
  public String file_extension="";
  public String prefix="";
  protected IProtoClass pc;
  public PrintWriter out;
  protected Pair p;
  protected String s;
  protected Property prop;
  protected Enumeration iterator;

protected void createfile(IProtoClass class_to_compile) throws IOException
{
      pc=class_to_compile;
      System.out.println("Creating file\n");
      if(pc==null) System.out.println("pc is null!");
      out=new PrintWriter(new FileWriter(prefix+pc.name()+file_extension));
System.out.println(out);

      IProtoClass parent=(IProtoClass)Database.main.parent.subject(pc);
      if(parent==null) throw new IOException("No parent");

      write(pc);
      out.close();
}

abstract public void write(IProtoClass pc) throws IOException;

  public void preprocess(String name) throws InterruptedException, IOException
  {
    Process proc;

    System.out.println("Preprocessing...");
  }

  public void process(String name) throws InterruptedException, IOException
  {
    Process proc;
    char c;
    InputStream in;

    proc=rt.exec("compile "+name);
    System.out.println("Compiling...");
    in=proc.getInputStream();
    proc.waitFor();
/*    do
    {
      c=(char)in.read();
      if(c!=-1) System.out.write(c);
    }
    while(c!=-1);
*/    in.close();
  }

public void cleanup(String name)
{
  File f=new File(name+"."+file_extension);
  f.renameTo(new File("src/"+name+"."+file_extension));
  f=new File(name+".class");
  f.renameTo(new File("../../user/mud/user/"+name+".class"));
}

public String print(Property prop)
{
  String type=prop.type;
  Object obj=prop.object;

  if(type.equals("Integer"))
  {
    return "new Integer("+obj+")";
  }
  else if(Types.list.isInstance(obj))
  {
    return "new MudArray(\""+obj+"\")";
  }
  else if(type.equals("String"))
  {
    return "\""+obj+"\"";
  }
  else if(Types.object.isInstance(obj))
  {
    MObject mo=(MObject)obj;
    String p="";
    p=mo.getparent().name();
    if(Database.types.checktype(p, obj))
    {
      MudObject mudobj=(MudObject)obj;
      return mudobj.toString();
    }
    else
      return "null";
  }
  return "null";
}
}
