package momoko.compiler;

import momoko.util.*;
import momoko.protoclass.*;
import momoko.*;
import java.util.*;
import java.io.*;

/**
 * 
 */
public class PearlSourceObject extends ProtoClassSourceObject
{
  public Vector interfaces=new Vector();
  public Vector cons=new Vector();
  public Vector getters=new Vector();
  public Vector setters=new Vector();

public PearlSourceObject(ProtoClassSourceObject pc)
{
    setName(pc.getName());
    setParent(pc.getParent());
    setPackage(pc.getPackage());
    setLibraries(pc.getLibraries());
    Vector source=new Vector();
    source.add("this(\"\");");
    addConstructor(new Constructor(getName(), new Vector(), source));
    source=new Vector();
    source.add("super(name);");
    Vector args=new Vector();
    args.add(new Pair("String","name"));
    addConstructor(new Constructor(getName(), args, source));
}

public PearlSourceObject(IProtoClass pc) throws IOException
{
  super(pc);
  Vector source=new Vector();
  source.add("this(\"\");");
  addConstructor(new Constructor(getName(), new Vector(), source));
  source=new Vector();
  source.add("super(name);");
  Vector args=new Vector();
  args.add(new Pair("String","name"));
  addConstructor(new Constructor(getName(), args, source));
}

  public void addMethod(GetterMethod gm) {getters.addElement(gm);}
  public void addMethod(SetterMethod sm) {setters.addElement(sm);}
  public Vector getGetters() {return getters;}
  public Vector getSetters() {return setters;}
  public void addInterface(String i) {interfaces.addElement(i);}
  public Vector getInterfaces() {return interfaces;}
  public void clearConstructors() {cons=new Vector();}
  public void addConstructor(Constructor c) {cons.addElement(c);}
  public Vector getConstructors() {return cons;}
}
