package momoko.compiler;

import momoko.*;
import java.util.*;
import java.io.*;

/**
 * 
 */
public class ProtoClassSourceObject
{
  private String name;
  private String parent;
  private PackageDeclaration pkg;
  private Vector libraries=new Vector();
  private Vector variables=new Vector();
  private Vector methods=new Vector();

  public ProtoClassSourceObject()
  {
  }

public ProtoClassSourceObject(IProtoClass pc) throws IOException
{
      System.out.println("new protoclasssourceobject");
      if(pc==null) System.out.println("pc is null!");

//      ProtoClass parent=(ProtoClass)Database.main.parent.subject(pc);
      String parentname=pc.getParentName();
//      if(parent==null) throw new IOException("No parent");

      setName(pc.name());
//      setParent(parent.name());
      setParent(parentname);
      setPackage("mud.user");
      addLibrary(new Library("java.util", "*"));
      addLibrary(new Library("mud.shared.types","MudArray"));
      
      Enumeration iterator=pc.getproperties().keys();
      while(iterator.hasMoreElements())
      {
        String name=(String)iterator.nextElement();
        addProperty(name, (Property)pc.getproperties().get(name));
      }
}

  public void addProperty(String name, Property value)
  {
//System.out.println("pearl addproperty "+name+" "+value);
    if(value.type.equals("Function"))
      addMethod(new Method(name, (Function)value.object));
    else
    {
      //System.out.println(value.type+" "+name+" "+value.object);
      addVariable(new Variable(value.type, name, value.object));
      addMethod(new GetterMethod(name, value.type));
      addMethod(new SetterMethod(name, value.type));
    }
  }

  public void clearMethods()
  {
    methods=new Vector();
  }

  public void setName(String n) {name=n;}
  public String getName() {return name;}
  public void setParent(String p) {parent=p;}
  public String getParent() {return parent;}
  public void setPackage(String p) {pkg=new PackageDeclaration(p);}
  public void setPackage(PackageDeclaration p) {pkg=p;}
  public PackageDeclaration getPackage() {return pkg;}
  public void addLibrary(Library l) {libraries.addElement(l);}
  public Vector getLibraries() {return libraries;}
  public void setLibraries(Vector l) {libraries=l;}
  public void addMethod(Method m) {methods.addElement(m);}
  public void addVariable(Variable v) {variables.addElement(v);}
  public Vector getVariables() {return variables;}
  public Vector getMethods() {return methods;}
}
