package momoko.compiler;

import momoko.*;
import java.util.*;
import momoko.types.*;
import java.io.*;
import java.lang.String;
import java.util.*;

/**
 * 
 */
abstract public class TransformingCompiler extends Compiler
{
  public String file_extension="";
  public String prefix="";
  protected IProtoClass pc;
  public PrintWriter out;
  protected Pair p;
  protected String s;
  protected Property prop;
  protected Enumeration iterator;
  protected Vector transforms=new Vector();

  public void addTransformation(Transformation transform)
  {
    transforms.addElement(transform);
  }

  public void preprocess(String name) throws InterruptedException, IOException
  {
    Process proc;

    System.out.println("Preprocessing...");
  }


public File createfile(IProtoClass pc) throws IOException
{
  Hashtable classes=new Hashtable();
  classes.put("source", new PearlSourceObject(pc));
  Enumeration iterator=transforms.elements();
  while(iterator.hasMoreElements())
  {
    Transformation transform=(Transformation)iterator.nextElement();
    transform.transform(classes);
  }

  iterator=classes.keys();

  while(iterator.hasMoreElements())
  {
      String clsname=(String)iterator.nextElement();
      ProtoClassSourceObject cls=(ProtoClassSourceObject)classes.get(clsname);
      System.out.println(clsname);
      System.out.println("Creating file: "+prefix+cls.getName()+"\n");
      out=new PrintWriter(new FileWriter(prefix+cls.getName()));
      System.out.println(out);
//      IProtoClass parent=(IProtoClass)Database.main.parent.subject(cls);
//      if(parent==null) throw new IOException("No parent");        
System.out.println("going to write "+cls);
      write(cls);
      out.close();
  }
  return new File(prefix+pc.getName());
}

abstract void write(ProtoClassSourceObject pc) throws IOException;

  public void process(String name) throws InterruptedException, IOException
  {
    Process proc;
    char c;
    InputStream in;

    proc=rt.exec("compile "+name);
    System.out.println("Compiling...");
    in=proc.getErrorStream();
    proc.waitFor();
/*    do
    {
      c=(char)in.read();
      if(c!=-1) System.out.write(c);
    }
    while(c!=-1);
*/    in.close();
  }

public void cleanup(String name)
{
  File f=new File(name+"."+file_extension);
  f.renameTo(new File("src/"+name+"."+file_extension));
  f=new File(name+".class");
  f.renameTo(new File("../../user/mud/user/"+name+".class"));
}

public String print(Property prop)
{
  String type=prop.type;
  Object obj=prop.object;

  if(type.equals("Integer"))
  {
    return "new Integer("+obj+")";
  }
  else if(Types.list.isInstance(obj))
  {
    return "new MudArray(\""+obj+"\")";
  }
  else if(type.equals("String"))
  {
    return "\""+obj+"\"";
  }
  else if(Types.object.isInstance(obj))
  {
    MObject mo=(MObject)obj;
    String p="";
    p=mo.getparent().name();
    if(Database.types.checktype(p, obj))
    {
      MudObject mudobj=(MudObject)obj;
      return mudobj.toString();
    }
    else
      return "null";
  }
  return "null";
}
}
