package momoko.compiler.jenesis;

import momoko.protoclass.*;
import momoko.versioncontrol.*;
import momoko.compiler.*;
import momoko.*;
import momoko.util.*;
import java.io.*;
import org.inxar.jenesis.*;
import java.util.*;

public class JenesisSourceWriter
{
  VirtualMachine vm;

  public void write(File f, IProtoClass p)
  {
try{
    vm=VirtualMachine.getVirtualMachine();
    CompilationUnit unit=vm.newCompilationUnit(f.getAbsolutePath());
    convert(p, unit);
    unit.encode();    
}
catch(Exception e) {e.printStackTrace();}
  }

  protected void convert(IProtoClass p, CompilationUnit unit)
  {
    String name=p.getName();
    System.out.println("Writing source for class "+name);
    int i=name.lastIndexOf('.');
    String pkg=name.substring(0, i);
    name=name.substring(i+1);
    unit.setNamespace(pkg);
    PackageClass cls = unit.newClass(name);
    cls.setExtends("Object");
    Map props = p.getproperties();
    System.out.println("properties: "+props);
    java.util.Iterator iterator=props.keySet().iterator();
    while(iterator.hasNext())
    {
      String s=(String)iterator.next();
      Property prop = (Property)props.get(s);
      if(prop.type.equals("Function"))
        addMethod(cls, s, (Function)prop.object);
      else
        addVariable(cls, prop);
    }
  }

  protected void addMethod(PackageClass cls, String name, Function f)
  {
    System.out.println("Adding method "+name+" "+f);
    String type=f.get_returnType();
    ClassMethod method = cls.newMethod(convertType(type), name);
    method.isNative(false);
    method.isSynchronized(false);
    method.isAbstract(false);
    method.setAccess(Access.PUBLIC);
    method.isStatic(false);
    Vector v=f.get_args();
    Enumeration iterator = v.elements();
    while(iterator.hasMoreElements())
    {
      Pair p=(Pair)iterator.nextElement();
      type=(String)p.first;
      name=(String)p.second;
      System.out.println("Adding parameter "+type+" "+name);
      method.addParameter(convertType(type), name);
    }
  }

  protected void addVariable(PackageClass cls, Property prop)
  {
  }

  protected Type convertType(String s)
  {
/*
    if(s.equals("void"))
      return vm.newType(Type.VOID);
    else
      return vm.newType(Type.CLASS);
*/
    return vm.newArray("String", 1);
  }
}
