package momoko.extra;

import momoko.*;
import momoko.user.*;

public class Raven extends User implements IUser
{
  String mstr;
  transient IUser master;

  public Raven (String name)
  {
    super(name);
  }

  public void setMaster(String newmaster)
  {
    mstr=newmaster;
    try { master=(IUser)Database.main.root.resolve(mstr); }
    catch(Exception e) {e.printStackTrace();}
  }

  public void whisper(IUser user, String args)
  {
    if(user==null) return;
    if(user.equals(master))
    {
      Room room=(Room)location();
      if(room==null) return;
      room.say(this, args);
    }
    else
      super.whisper(user, args);
  }

  public void notify(String args)
  {
    System.out.println("notify("+args+")");
    if(master==null)
    {
      if(mstr==null) return;
      try { master=(IUser)Database.main.root.resolve(mstr); }
      catch(Exception e) {e.printStackTrace(); return;}
    }
    System.out.println("telling "+master);
    master.tell(getName()+": "+args);
  }
}
