package momoko.forum;

import java.util.*;
import java.lang.reflect.*;
import javax.mail.*;

public class EnumerationProxy implements java.lang.reflect.InvocationHandler {

    private Enumeration obj;

    public static Object newInstance(Object obj) {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            getInterfaces(obj),
            new EnumerationProxy(obj));
    }

    private EnumerationProxy(Object obj) {
        this.obj = (Enumeration)obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            result = m.invoke(obj, args);
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
        }
        if(result instanceof Header)
          result=IHeaderProxy.newInstance(result);
        return result;
    }

  static public Class[] getInterfaces(Object o)
  {
    Class[] i=o.getClass().getInterfaces();
    boolean found=false;
    Class[] i2=new Class[i.length+1];
    int x;
    for(x=0;x<i.length;x++)
    {
      i2[x]=i[x];
      if(i[x].equals(Enumeration.class)) found=true;
    }
    if(found) return i;
    else
    {
      i2[x]=Enumeration.class;
      return i2;
    }
  }
}
