package momoko.forum;

import momoko.*;
import momoko.user.*;
import java.util.Date;

public class GenericUser extends Admin implements momoko.forum.User, IMObject, java.io.Serializable
{
  private String password;
  protected boolean connectedStatus;
  protected Date lastActionTime;

  public GenericUser() {this("");}
  public GenericUser(String name) {super(name);}

  public void setPassword(String newpassword)
  {
    password=newpassword;
  }

  public String getPassword()
  {
    return password;
  }

  public boolean authenticate(String newpassword)
  {
    String crypt=JCrypt.crypt(password, newpassword);
    return crypt.equals(password);
  }

  public Date getLastActionTime() {return lastActionTime;}
  public void setLastActionTime(Date d) {lastActionTime=d;}

  public boolean getConnectedStatus()
  {
    if(!connectedStatus) return connectedStatus;
    if(lastActionTime==null) return connectedStatus;
    if(lastActionTime.after(new Date())) return connectedStatus;
    long now=new Date().getTime();
    long then=lastActionTime.getTime();
    long interval=now-then;
    long minutes=interval/(1000*60);
//    System.out.println("User "+getName()+" has been idle "+minutes+" minutes.");
    if(minutes>5) connectedStatus=false;
    return connectedStatus;
  }

  public void setConnectedStatus(boolean b) {connectedStatus=b;}

  public long getIdleTime()
  {
    if(lastActionTime==null) return 0;
    long now = new Date().getTime();
    long then = lastActionTime.getTime();
    return now-then;
  }

  public String getIdleTimeString()
  {
    String s="";
    long time = getIdleTime() / 1000;

    if(time==0) return "0 seconds";

    long years = time / (60*60*24*365);
    time = time % (60*60*24*365);
    if(years!=0) s=s+years+" years";

    long months = time / (60*60*24*30);
    time = time % (60*60*24*30);
    if(months!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s+months+" months";
    }

    long weeks = time / (60*60*24*7);
    time = time % (60*60*24*7);
    if(weeks!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s+weeks+" weeks";
    }

    long days = time / (60*60*24);
    time = time % (60*60*24);
    if(days!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s+days+" days";
    }

    long hours = time / (60*60);
    time = time % (60*60);
    if(hours!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s=+hours+" hours";
    }

    long minutes = time / 60;
    time = time % 60;
    if(minutes!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s+minutes+" minutes";
    }

    if(time!=0)
    {
      if(!s.equals("")) s=s+", ";
      s=s+time+" seconds";
    }

    return s;
  }
}
