package momoko.forum;

import javax.mail.*;
import javax.mail.event.*;
import javax.mail.search.*;

public interface IFolder
{
    public    String getName();
    public    String getFullName();
    public  URLName getURLName() throws  MessagingException;
    public  Store getStore();
    public    Folder getParent() throws  MessagingException;
    public   boolean exists() throws  MessagingException;
    public    Folder[] list( String s) throws
MessagingException;
    public  Folder[] listSubscribed( String s) throws
MessagingException;
    public  Folder[] list() throws  MessagingException;
    public  Folder[] listSubscribed() throws  MessagingException;
    public   char getSeparator() throws  MessagingException;
    public   int getType() throws  MessagingException;
    public   boolean create(int i) throws  MessagingException;
    public boolean isSubscribed();
    public void setSubscribed(boolean b) throws  MessagingException;
    public   boolean hasNewMessages() throws  MessagingException;
    public    Folder getFolder(String s) throws  MessagingException;
    public   boolean delete(boolean b) throws  MessagingException;
    public   boolean renameTo( Folder f) throws  MessagingException;
    public   void open(int i) throws  MessagingException;
    public   void close(boolean b) throws  MessagingException;
    public   boolean isOpen();
    public int getMode();
    public    Flags getPermanentFlags();
    public   int getMessageCount() throws  MessagingException;
    public   int getNewMessageCount() throws  MessagingException;
    public   int getUnreadMessageCount() throws  MessagingException;
    public    IMessage getMessage(int i) throws  MessagingException;
    public    IMessage[] getMessages(int a, int b) throws
MessagingException;
    public    IMessage[] getMessages(int[] i) throws
MessagingException;
    public    IMessage[] getMessages() throws
MessagingException;
    public   void appendMessages( IMessage[] m) throws
MessagingException;
    public void fetch( IMessage[] n,  FetchProfile a) throws
MessagingException;
    public   void setFlags( IMessage[] a,  Flags d, boolean f)
throws  MessagingException;
    public   void setFlags(int a, int d,  Flags s, boolean f)
throws MessagingException;
    public   void setFlags(int[] a,  Flags d, boolean e)
throws MessagingException;
    public void copyMessages( IMessage[] d,  Folder a) throws
MessagingException;
    public    IMessage[] expunge() throws  MessagingException;
    public  IMessage[] search(SearchTerm d) throws
MessagingException;
    public  IMessage[] search(SearchTerm d,  IMessage[] a)
throws MessagingException;
    public   void addConnectionListener(ConnectionListener d);
    public   void removeConnectionListener(ConnectionListener d);
    public   void addFolderListener(FolderListener d);
    public   void removeFolderListener(FolderListener d);
    public   void addMessageCountListener(MessageCountListener d);
    public   void removeMessageCountListener(MessageCountListener d);
    public   void addMessageChangedListener(MessageChangedListener d);
    public   void removeMessageChangedListener(MessageChangedListener d);
    public  String toString();
}
