package momoko.forum;

import java.util.*;
import java.lang.reflect.*;
import javax.mail.*;

public class IMessageProxy implements java.lang.reflect.InvocationHandler {

    protected boolean debug=false;
    private Message obj;

    public static Object newInstance(Object obj) {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            getInterfaces(obj),
            new IMessageProxy(obj));
    }

    private IMessageProxy(Object obj) {
        this.obj = (Message)obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            if(m.getName().equals("getSender"))
            {
              Method m2=obj.getClass().getMethod("getFrom", m.getParameterTypes());
              Object[] temp = (Object[])m2.invoke(obj, args);
              result = temp[0];
            }
            else
            {
              Method m2=obj.getClass().getMethod(m.getName(), m.getParameterTypes());
              result = m2.invoke(obj, args);
            }
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            e.printStackTrace();
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
        }
        if(result==null)
        {
          if(debug) System.out.println("result for "+m.getName()+" is null.");
          return null;
        }
        if(result instanceof Folder)
          if(!Proxy.isProxyClass(result.getClass()))
            result=MailFolderProxy.newInstance(result);
        if(result instanceof Message)
          if(!Proxy.isProxyClass(result.getClass()))
            result=IMessageProxy.newInstance(result);
        if(result instanceof Enumeration)
          result=EnumerationProxy.newInstance(result);
        if(result.getClass().isArray())
        {
          Object[] oarr=(Object[])result;
          Object[] o2=new Object[oarr.length];
          for(int x=0;x<oarr.length;x++)
          {
            Object o=oarr[x];
            if(o instanceof Message)
              if(!Proxy.isProxyClass(result.getClass()))
                o=IMessageProxy.newInstance(o);
            o2[x]=o;
          }
          result=(Object)o2;
        }
        if(debug) System.out.println("Returning: "+result);
        if(debug) System.out.println("Return type should be "+m.getReturnType());
        if(debug) System.out.println("It is "+result.getClass());
        if(!m.getReturnType().equals(result.getClass()))
        {
          if(debug) System.out.println("Types don't match!");
          Class good=m.getReturnType();
          Class bad=result.getClass();
          if(good.isArray() && bad.isArray())
          {
            if(debug) System.out.println("At least they're both arrays.");
            Object goodArray=Array.newInstance(good.getComponentType(), Array.getLength(result));
            for(int x=0;x<Array.getLength(result);x++)
            {
              Object element=Array.get(result, x);
              if(debug) System.out.println("element: "+element);
              Array.set(goodArray, x, Array.get(result, x));
            }
            result=goodArray;
          }
        }
        return result;
    }

  static public Class[] getInterfaces(Object o)
  {
    Class[] i=o.getClass().getInterfaces();
    boolean found=false;
    Class[] i2=new Class[i.length+1];
    int x;
    for(x=0;x<i.length;x++)
    {
      i2[x]=i[x];
      if(i[x].equals(IMessage.class)) found=true;
    }
    if(found) return i;
    else
    {
      i2[x]=IMessage.class;
      return i2;
    }
  }
}
