package momoko.forum;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import javax.mail.*;
import JSX.*;

/**
 *  a multi-user aware object
 */
public class JSXSerializationDB extends MObject implements Remote
{
  File f;

public JSXSerializationDB(String newname)
{
  super(newname);
}

public void setPath(String path)
{
  setcontents(new Hashtable());
try{
  f=new File(path);
  if(!f.exists()) {f.mkdir(); return;}
  String[] files=f.list();
  for(int x=0; x<files.length;x++)
  {
    File file=new File(path, files[x]);
    FileInputStream fis=new FileInputStream(file);
    ObjIn os=new ObjIn(fis);
    Object o=(Object)os.readObject();
//System.out.println("JSX DB: "+o);
/*
    if(o instanceof SoftReference)
    {
      SoftReference ref=(SoftReference)o;
      o=SoftProxy.newInstance(ref.getName(), ref.getPath());
    }
*/
    Database.main.move((IMObject)o, this);
  }
}catch(Exception e) {e.printStackTrace();}
}

public Map contents()
{
//  System.out.println("This should be happening remotely.");
  return super.contents();
}

public boolean accept(IMObject obj)
{
  if(!(obj instanceof Serializable) && !(obj instanceof Externalizable))
  {System.out.println("not serializable"); return false;}
  if(f==null) {System.out.println("db not initialized"); return false;}
  return true;
}

public void enterfunc(IMObject mobj)
{
  Object obj=mobj;
try{
  if(f==null) return;
  if(!(obj instanceof Serializable) && !(obj instanceof Externalizable)) return;
  File file=new File(f, mobj.getName());
  FileOutputStream fos=new FileOutputStream(file);
  if(obj instanceof Proxy)
  {
    InvocationHandler handler = Proxy.getInvocationHandler(obj);
/*
    if(handler instanceof SoftProxy)
    {
      obj=((SoftProxy)handler).getReference();
    }
*/
  }
  ObjOut os=new ObjOut(fos);
  os.writeObject(obj);
//  os.close();
}catch(Exception e) {e.printStackTrace();}
}

public void exitfunc(IMObject obj)
{
try{
  if(f==null) return;
  File file=new File(f, obj.getName());
  if(file.exists()) f.delete();
}catch(Exception e) {e.printStackTrace();}
}
}
