package momoko.forum;

import java.lang.reflect.*;
import javax.mail.*;

public class MailFolderProxy implements java.lang.reflect.InvocationHandler {

    static public boolean debug=false;
    private Folder obj;

    public static Object newInstance(Object obj) {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            getInterfaces(obj),
            new MailFolderProxy(obj));
    }

    private MailFolderProxy(Object obj) {
        this.obj = (Folder)obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            if(m.getName().equals("getFrom")) result=getFrom(m, args);
            else
            {
              String name=m.getName();
              Class[] classes=m.getParameterTypes();
              if(debug) System.out.println("secondary lookup "+name+" "+classes);
              Method m2=obj.getClass().getMethod(name, classes);
              result = m2.invoke(obj, args);
            }
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
        }
if(debug) System.out.println("result was: "+result);
if(result!=null)
  if(debug) System.out.println(result.getClass());
if(result!=null)
  if(debug) System.out.println(result.getClass().isArray());
        if(result==null)
          return result;
        if(result instanceof Folder)
          if(!Proxy.isProxyClass(result.getClass()))
            result=MailFolderProxy.newInstance(result);
        if(result instanceof Message)
          if(!Proxy.isProxyClass(result.getClass()))
            result=IMessageProxy.newInstance(result);
        if(result.getClass().isArray())
        {
if(debug) System.out.println("in isarray");
          Object[] oarr=(Object[])result;
if(debug) System.out.println("oarr: "+oarr);
          Class arrc=result.getClass().getComponentType();
          if(!arrc.equals(javax.mail.Message.class)) return result;
          IMessage[] o2=new IMessage[oarr.length];
          for(int x=0;x<oarr.length;x++)
          {
            Message o=(Message)oarr[x];
            o2[x]=(IMessage)IMessageProxy.newInstance(o);
          }
          result=(Object)o2;
        }
        return result;
    }

  static public Class[] getInterfaces(Object o)
  {
    Class[] i=o.getClass().getInterfaces();
    boolean found=false;
    Class[] i2=new Class[i.length+1];
    int x;
    for(x=0;x<i.length;x++)
    {
      i2[x]=i[x];
      if(i[x].equals(IFolder.class)) found=true;
    }
    if(found) return i;
    else
    {
      i2[x]=IFolder.class;
      return i2;
    }
  }

  public String getFrom(Method m, Object[] objects) throws Exception
  {
    Address[] addr=(Address[])m.invoke(obj, objects);
    if(addr.length==0) return "Unknown";
    return addr[0].toString();
  }
}

