package momoko.forum;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import javax.mail.*;
import javax.mail.Session;
import momoko.protoclass.*;

/**
 *  a multi-user aware object
 */
public class MailServer extends MObject
{
  static public boolean debug=false;
  Session session;
  Store store;

/**
 *  create a new object without a name
 */
public MailServer()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public MailServer(String newname)
{
  super(newname);
  if(debug) System.out.println("getting store "+newname);
  try
  {
    session=Session.getDefaultInstance(System.getProperties(), null);
    session.setDebug(true);
    store=session.getStore(newname);
    if(debug) System.out.println("store: "+store);
  }
  catch(Exception e) {e.printStackTrace();}
}

public IMObject create(IProtoClass parent, String path, String name) throws IllegalArgumentException, BadPathException
{
  return super.create(parent, path, name);
}

private IMObject regenerate(String name)
{
  if(debug) System.out.println("registering folder "+name);
  MailFolder folder=null;
  try
  {
    folder=(MailFolder)subdir.get(name);

    if(folder==null)
    {
      folder=new GenericMailFolder(name, store);
      Database.main.move(folder, this);
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
  return folder;
}

public IMObject resolve(String path) throws BadPathException
{
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  IMObject folder=regenerate(prefix);
  if(folder==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return folder;
  }
  else
    return folder.resolve(suffix);
}
}
