package momoko.forum;

import javax.mail.*;
import javax.mail.internet.*;
import com.ice.javamail.mh.*;

import java.util.*;
import java.io.*;
import momoko.*;
import momoko.server.*;
import momoko.stream.*;

public class POPAuthServer extends Interpreter
{
  Interpreter oldi;
  Parser oldp;
  String foldername;
  IFolder folder;
  User user;

  String mailPath="/world/mail/mh";
  String dbPath="/world/db";

  public void initialize()
  {
    handler.format("+OK POP3 Server ready");
  }

    public void setMailPath(String newMailPath)
    {
	mailPath=newMailPath;
    }

    public String getMailPath()
    {
	return mailPath;
    }

    public void setDbPath(String newDbPath)
    {
	dbPath=newDbPath;
    }

    public String getDbPath()
    {
	return dbPath;
    }

  public boolean interpret(Object command)
  {
System.out.println(command);
    try
    {
      String[] args=(String[])command;
      System.out.println(args[0]);
      if(args[0].equals("USER"))
      {
	  try
	  {
	      user=(User)Database.main.root.resolve(dbPath+"/"+args[1]);
              MailFolder f=(MailFolder)Database.main.root.resolve(mailPath+"/"+args[1]);
	      folder=f.getFolder();
	      foldername=args[1];
	      handler.format("+OK");
          }
	  catch(Exception e) {e.printStackTrace(); handler.format("-ERR No such account");}
      }
      else if(args[0].equals("PASS"))
      {
        try
	    {
          if(!user.authenticate(args[1]))
	  {
		  handler.format("-ERR Wrong password");
		  return true;
	  }
	    }
	catch(Exception e) {e.printStackTrace(); handler.format("-ERR Exception"); return true;}

	  new POPServer(folder, handler);
      }
      else if(args[0].equals("QUIT"))
	  {
	      handler.format("+OK");
	      return false;
	  }
    }
    catch(ClassCastException e) {return false;}
    return true;
  }
}
