package momoko.forum;

import javax.mail.*;
import javax.mail.internet.*;
import com.ice.javamail.mh.*;

import java.util.*;
import java.io.*;
import momoko.*;
import momoko.server.*;
import momoko.stream.*;

public class POPServer extends Interpreter
{
  Interpreter oldi;
  Parser oldp;
  String foldername;
  IFolder folder;
  boolean running;

  public POPServer(IFolder f, StreamHandler handler)
  {
    super();
    oldi=handler.getInterpreter();
    oldp=handler.getParser();
    handler.setinterpreter(this);
    handler.setparser(new WordParser());

    folder=f;
    System.out.println(folder);

    handler.format("+OK");
  }

  public boolean interpret(Object command)
  {
    try
    {
      String[] args=(String[])command;
      System.out.println(args[0]);
      if(args[0].equals("NOOP"))
      {
        handler.format("+OK");
      }
      else if(args[0].equals("STAT"))
      {
        try
        {
          handler.format("+OK "+folder.getMessageCount()+" "+folder.getMessageCount()*256);
        }
        catch(Exception e) {handler.format("-ERR "+e);}
      }
      else if(args[0].equals("RETR"))
      {
        int msgnum=Integer.parseInt(args[1]);
        try
        {
         IMessage m=folder.getMessage(msgnum); 
         handler.format("+OK 1000000 octets");
         Enumeration iterator=(m.getAllHeaders());
         while(iterator.hasMoreElements())
         {
          IHeader header=(IHeader)iterator.nextElement();
          handler.format(header.getName()+": "+header.getValue());
         }
	 handler.format("");
         handler.format(m.getContent());
         handler.format(".");
        }
        catch(Exception e)
        {
          handler.format("-ERR "+e);
          return true;
        }
      }
      else if(args[0].equals("TOP"))
      {
        int msgnum=Integer.parseInt(args[1]);
        try
        {
         IMessage m=folder.getMessage(msgnum); 
         handler.format("+OK");
         Enumeration iterator=m.getAllHeaders();
         while(iterator.hasMoreElements())
         {
          IHeader header=(IHeader)iterator.nextElement();
          System.out.println("header: "+header);
          handler.format(header.getName()+": "+header.getValue());
         }
	 handler.format("");
         handler.format(".");
        }
        catch(Exception e)
        {
          handler.format("-ERR "+e);
          e.printStackTrace();
          return true;
        }
      }
      else if(args[0].equals("LIST"))
      {
        int msgnum=Integer.parseInt(args[1]);
        try
        {
         MimeMessage m=(MimeMessage)folder.getMessage(msgnum); 
         handler.format("+OK "+args[1]+" 255");
        }
        catch(Exception e)
        {
          handler.format("-ERR "+e);
          return true;
        }
      }
      else if(args[0].equals("UIDL"))
      {
        int msgnum=Integer.parseInt(args[1]);
        try
        {
         MimeMessage m=(MimeMessage)folder.getMessage(msgnum); 
         handler.format("+OK "+args[1]+" 35ef160d3907"+args[1]);
        }
        catch(Exception e)
        {
          handler.format("-ERR "+e);
          return true;
        }
      }
	  else if(args[0].equals("DELE"))
      {
        int msgnum=Integer.parseInt(args[1]);
        try
        {
         MimeMessage m=(MimeMessage)folder.getMessage(msgnum); 
         handler.format("+OK "+args[1]+" 35ef160d3907"+args[1]);
        }
        catch(Exception e)
        {
          handler.format("-ERR "+e);
          return true;
        }
      }
      else if(args[0].equals("QUIT"))
      {
                  handler.format("+OK");
		  return false;
      }
    }
    catch(ClassCastException e) {return false;}
    return true;
  }
}
