package momoko.proxy;

import java.lang.reflect.*;

public class InterfaceProxy implements java.lang.reflect.InvocationHandler, java.rmi.Remote {

    private Object obj;

    public static Object newInstance(Object obj, Class inter) {
        Class[] interfaces=obj.getClass().getInterfaces();
        Class[] i2=new Class[interfaces.length+1];
        int x;
	for(x=0;x<interfaces.length;x++)
          i2[x]=interfaces[x];
        i2[x]=inter;
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            i2,
            new InterfaceProxy(obj));
    }

    private InterfaceProxy(Object obj) {
        this.obj = obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
        Object result;

        try
        {
            System.out.println("before method " + m.getName());
System.out.println("Trying to call "+m.getName()+" on "+obj.getClass());
            Class c=obj.getClass();
            Class[] classes;
            if(args==null) classes=new Class[] {};
            else if(args.length>0)
            {
              classes=new Class[args.length];
              for(int x=0;x<args.length;x++)
                classes[x]=args[x].getClass();
            }
            else classes=new Class[] {};
            Method m2=c.getMethod(m.getName(), classes);
            result = m2.invoke(obj, args);
        } 
        catch (InvocationTargetException e)
        {
            throw e.getTargetException();
        } catch (Exception e)
        {
            e.printStackTrace();
            throw new RuntimeException("unexpected invocation exception: " +
                                       e.getMessage());
        }
        finally
        {
            System.out.println("after method " + m.getName());
        }
        System.out.println("returning "+result);
        return result;
    }
}
