package momoko.proxy;

import momoko.*;
import java.util.*;
import java.io.IOException;
import java.lang.reflect.*;

public class MObjectProxy extends DelegationProxy implements java.rmi.Remote
{
    static public boolean debug=false;

static public IMObject newInstance(String name, Object obj)
{
  return makeProxy(name, obj);
}

static public IMObject makeProxy(String name, Object obj)
{
      Class[] i, i2;
      i=obj.getClass().getInterfaces();
      i2=new Class[i.length+1];
      int x;
      for(x=0; x<i.length; x++)
      {
        i2[x]=i[x];
//        if(debug) System.out.println("Has interface "+i[x]);
      }
      i2[x]=IMObject.class;
      return (IMObject)java.lang.reflect.Proxy.newProxyInstance(
        obj.getClass().getClassLoader(), i2, new MObjectProxy(name, obj, i2));
    }

    public MObjectProxy(String name, Object object, Class[] interfaces)
    {
      super(interfaces, MObjectProxy.makeObjects(name, object, interfaces));
    }

    static private Object[] makeObjects(String name, Object object, Class[] interfaces)
    {
      Object[] carr=new Object[interfaces.length];
      int x;
      for(x=0;x<interfaces.length-1;x++)
      {
        carr[x]=object;
//        if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      }
      carr[x]=new MObject(name);
//      if(debug) System.out.println(interfaces[x]+" <-> "+carr[x]);
      return carr;
    }

    public Object invoke(Object proxy, Method m, Object[] args)
        throws Throwable
    {
if(m.getName().equals("location"))
{
if(debug) System.out.println("MObjectProxy.location");
if(debug) System.out.println("returning "+Database.main.contains.subject(proxy));
return Database.main.contains.subject(proxy);
}

if(m.getName().equals("makeLink"))
{
  if(debug) System.out.println("MObjectProxy.makeLink");
  return MObject.doMakeLink((IMObject)proxy);
}
if(m.getName().equals("getAbsolutePath"))
{
  if(debug) System.out.println("MObjectProxy.getAbsolutePath");
  return MObject.doAbsolutePath((IMObject)proxy);
}
      return super.invoke(proxy, m, args);
    }
}
