package momoko.rmi;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import momoko.*;
import momoko.rpc.*;
import momoko.user.*;
import java.rmi.registry.Registry;

public class RMIClient implements RemoteObjectClient
{
  Registry registry;
  static protected boolean debug = false;

  public void initialize(String hostname, int port) throws Exception
  {
    registry=LocateRegistry.getRegistry(hostname, port);
    if(debug) System.out.println("Creating a registry for "+hostname+" "+port);
    if(debug) System.out.println("registry: "+registry);
  }

  public Remote lookup(String name) throws Exception
  {
    if(registry==null)
      return null;
    else
      return (Remote)registry.lookup(name);
  }

  public void shutdown()
  {
  }
}
