package momoko.server;

import java.io.*;
import java.util.*;

/**
 *  holds access services
 */
public class ServiceManager
{
  Hashtable services=new Hashtable();

/**
 *  loads services specified in config file
 */
  public ServiceManager(String configfile)
  {
    Properties props=new Properties();
    Properties props2;
    Class c;
    Enumeration iterator;
    String s1, s2;
    Service serv;

    try {props.load(new FileInputStream(configfile));}
    catch(Exception e)
    {
      System.out.println(e.toString());
      return;
    }

    iterator=props.propertyNames();
    while(iterator.hasMoreElements())
    {
      s1=(String)iterator.nextElement();
      try
      {
        s2="momoko.server."+props.getProperty(s1)+"Service";
        c=Class.forName(s2);
        serv=(Service)c.newInstance();
        props2=new Properties();
        props2.load(new FileInputStream("config/"+s1+".config"));
        serv.initialize(props2);
        services.put(s1, serv);
      }
      catch(Exception e)
      {
        System.out.println("Error loading service "+s1);
        System.out.println(e);
        continue; 
      }
    }
  }

  public void initialize()
  {
    Enumeration iterator=services.elements();
    while(iterator.hasMoreElements())
      try { ((Service)iterator.nextElement()).service(); }
      catch(Exception e)
      { e.printStackTrace(); }
  }

  public void display()
  {
    System.out.println("Services running:");
    Enumeration iterator=services.keys();
    while(iterator.hasMoreElements())
      System.out.println(iterator.nextElement());
    System.out.println(".");
  }

  public void shutdown()
  {
    Enumeration iterator=services.elements();
    while(iterator.hasMoreElements())
      ((Service)iterator.nextElement()).shutdown();
  }
}
