package momoko.server;

import java.util.*;
import momoko.Types;
import momoko.Formatter;

public class PythonFormatter extends LineFormatter
{
  public PythonFormatter() { super(); }

  public String format(Object o)
  {
    if(o instanceof Assignment)
    {
      Assignment a=(Assignment)o;
      String vstr;
      if(a.value==null)
        vstr="None";
      else
        vstr=format(a.value);
      return super.format(a.varname+"="+vstr);
    }
    else if(Types.list.isInstance(o))
    {
      Object item;
      Vector v=(Vector)o;
      String s="[";
      Enumeration iterator=v.elements();
      if(iterator.hasMoreElements())
        s=s+format(iterator.nextElement());
      while(iterator.hasMoreElements())
        s=s+","+format(iterator.nextElement());
      s=s+"]";
      return super.format(s);
    }
    else
      return super.format(o);
  }
}
