package momoko.straw;

import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;

/**
 *  a multi-user aware object
 */
public class StrawBundel extends MObject
{
  static public boolean debug=false;

/**
 *  create a new object without a name
 */
public StrawBundel()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public StrawBundel(String newname)
{
  super(newname);
}

private StrawOpening regenerate(String name)
{
  if(debug) System.out.println("registering channel "+name);
  StrawOpening opening;
  try
  {
    opening=(StrawOpening)subdir.get(name);

    if(opening==null)
    {
      opening=new StrawOpening(name);
      Database.main.move(opening, this);
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
  return opening;
}

public IMObject resolve(String path) throws BadPathException
{
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  StrawOpening opening=regenerate(prefix);
  if(opening==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return opening;
  }
  else
    return opening.resolve(suffix);
}
}
