package momoko.straw;

import java.net.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;
import momoko.*;
import java.lang.reflect.*;
import momoko.drivers.*;
import momoko.rpc.*;
import momoko.rmi.*;

/**
 *  a multi-user aware object
 */
public class StrawOpening extends MObject
{
  static public boolean debug=true;

/**
 *  create a new object without a name
 */
public StrawOpening()
{
  this("");
}

/**
 *  create a new object with the given name
 */
public StrawOpening(String newname)
{
  super(newname);
}

private IMObject regenerate(String name)
{
  if(debug) System.out.println("registering opening "+name);
  IMObject obj;
  try
  {
    obj=(IMObject)subdir.get(name);

    if(obj==null)
    {
      RemoteObjectClient remoteclient;
      remoteclient=new RMIClient();
      remoteclient.initialize(Database.main.getHostname(), Database.main.getPort());
      if(debug) System.out.println("remoteclient: "+remoteclient);
//      StrawBroker remote = (StrawBroker)remoteclient.lookup("StrawBroker");
      StrawBroker remote = (StrawBroker)java.rmi.Naming.lookup("//"+Database.main.getHostname()+":"+new Integer(Database.main.getPort()).toString()+"/StrawBroker");
      System.out.println("//"+Database.main.getHostname()+":"+new Integer(Database.main.getPort()).toString()+"/StrawBroker");
      if(debug) System.out.println("remote: "+remote);
      Object o=remote.lookup(name);
      if(o instanceof StrawReference)
      {
if(debug) System.out.println("StrawReference!");
        obj=(IMObject)StrawProxy.newInstance(remote, (StrawReference)o);
      }
      if(obj==null) throw new IllegalArgumentException("Proxy is null!");
      if(debug) System.out.println("~~~moving obj: "+obj);
      System.out.println("--MOVING");
      Database.main.move(obj, this);
      System.out.println("MOVING--");
    }
  }
  catch(Exception e) {e.printStackTrace(); return null;}
if(debug) System.out.println("regenerate is returning "+obj);
Class[] interfaces=obj.getClass().getInterfaces();
for(int x=0;x<interfaces.length;x++)
  if(debug) System.out.println(interfaces[x]);
  return obj;
}

public IMObject resolve(String path) throws BadPathException
{
  String prefix, suffix, temp=null;
  int i;
  boolean done=false;
  Enumeration iterator;
 
  i=path.indexOf('/');
  if(i==-1)
  {
    prefix=path;
    suffix="";
  }
  else
  {
    prefix = path.substring(0, i);
    suffix = path.substring(i+1);
  }

  IMObject obj=regenerate(prefix);
  if(obj==null) throw new BadPathException(path);

  if(suffix.equals(""))
  {
    return obj;
  }
  else
  {
//    if(debug) System.out.println("passing on resolve");
    return obj.resolve(suffix);
  }
}
}
