package momoko.stream;

import java.io.*;

public class Conduit extends Thread {
    private static int num = 0;

    private int cnum;
    private InputStream in;
    private OutputStream out;
    private long bytesToMove = -1;
    private long bytesMoved = 0;


    public Conduit(InputStream i, OutputStream o) {
	super("Conduit#" + (++num));
	setDaemon(false);
	this.in = i;
	this.out = o;
    }

    /**
     * Returns the number of bytes that have been read and written.
     * @return  The number of bytes moved.
     */
    public long bytesMoved() {
	return bytesMoved;
    }

    public void asyncFeed() {
	if (!isAlive()) {
	    this.start();
	}
    }

    public void asyncFeed(long n) {
	if (!isAlive()) {
	    this.bytesToMove = n;
	    this.start();
	}
    }
    
    public void run() {
	byte[] buffer = new byte[1024];
	int bytes_read;
	synchronized(in) {
	    synchronized(out) {
		try {
		    do {
			try {
			    bytes_read = in.read(buffer, 0, bytesToMove < 0 ||
						 (bytesToMove - bytesMoved >= 
						  buffer.length)
						 ? buffer.length
						 : (int) (bytesToMove - 
							  bytesMoved));
			} catch (IOException e) {
			    throw new ConduitException(e,in,out,true,
						       bytesMoved);
			    //System.out.println(new String(buffer));
			}
			try {
			    if (bytes_read > 0)
                            {
				out.write(buffer, 0, bytes_read);
			        bytesMoved = bytesMoved + bytes_read;
                            }
			} catch (IOException e) {
			    throw new ConduitException(e,in,out,false, 
						       bytesMoved);
			}
		    } while (bytes_read >= 0 && bytesMoved != bytesToMove);
		    
		    try {
			out.flush();
		    } catch (IOException e) {
			throw new ConduitException(e,in,out,false, bytesMoved);
		    }
		    if (bytesToMove != 0 && bytesMoved != bytesToMove) {
			throw new ConduitException(new EOFException(),
						   in,out,true, bytesMoved);
		    }
		} catch (ConduitException e) {
		} finally {
		    try {
			out.flush();
		    } catch (IOException ie) {
			ie.printStackTrace();
		    }
		}
	    }
	}
    }
}
