package momoko.versioncontrol;

import momoko.*;
import java.util.*;
import momoko.*;
import momoko.vfs.*;
import momoko.protoclass.*;

public class GenericVersionController extends MObject implements VersionController, java.rmi.Remote
{
  Vector versions=new Vector();
  Vector migrators=new Vector();
  Vector state;
  ProtoClass current;
  Migrator migrator;

  public GenericVersionController()
  {
    this("");
  }

  public GenericVersionController(String name)
  {
    super(name);
    newversion();
  }

  public VirtualFile getFileView()
  {
    return getCurrent().getFileView();
  }

  public IProtoClass getCurrent()
  {
    return current;
  }

  public IProtoClass newversion()
  {
    IMObject parent=null;
    if(current!=null)
      parent=current.getparent();
    current=new ProtoClass(name());
    if(parent!=null)
      current.initialize(parent.name());
    current.setController(this);
    if(!versions.isEmpty())
    {
      migrator=new Migrator();
      migrators.add(migrator);
    }
    versions.add(current);
    return current;
  }

  public void add(String name, Object value)
  {
    System.out.println("vc adding property");
    if(!migrators.isEmpty())
      migrator.add(new PropertyAddition(name, value));
  }

  public void migrate()
  {
    System.out.println("Migrating");
    savestate();
    migratestate();
    Database.loader.reinstantiate();
    restorestate();
  }

  private void savestate()
  {
    Vector children=Database.main.parent.objects(current);
    state = new Vector();
    if(children==null)
    {
      System.out.println("No children to migrate");
      return;
    }
    Enumeration iterator=children.elements();
    while(iterator.hasMoreElements())
      state.add(new ObjectInfo((MObject)iterator.nextElement()));
  }

  private void migratestate()
  {
    Enumeration iterator=state.elements();
    while(iterator.hasMoreElements())
      migrator.migrate((ObjectInfo)iterator.nextElement());
  }

  private void restorestate()
  {
    Enumeration iterator=state.elements();
    while(iterator.hasMoreElements())
      ((ObjectInfo)iterator.nextElement()).restore();
  }
}
