package momoko.vfs;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import javax.swing.filechooser.*;
import momoko.*;
import momoko.extra.*;

public class HttpFileChooser extends JFileChooser
{
    static public HttpFile fixFile(File f)
    {
/*      System.out.println("Trying to fix file: "+f);
      if(f==null) throw new NullPointerException();
      // return null;
      System.out.println("Path: "+f.getAbsolutePath());
      if(f instanceof HttpFile) return (HttpFile)f;
      else return new HttpFile(f.getAbsolutePath());
*/
    return (HttpFile)f;
    }

    static public HttpFile[] fixFiles(File[] fs)
    {
      if(fs==null) return null;
      for(int x=0;x<fs.length;x++)
        fs[x]=fixFile(fs[x]);
      return (HttpFile[])fs;
    }

    public HttpFileChooser( String s)
    {
      this(s, new HttpFileSystemView(s));
    }
    public HttpFileChooser( File f)
    {
      this(fixFile(f), new HttpFileSystemView(f.getAbsolutePath()));
    }
    public HttpFileChooser(  FileSystemView v) {super(v);}
    public  HttpFileChooser( File f,  FileSystemView v) {super(fixFile(f),v);}
    public  HttpFileChooser( String s,  FileSystemView v)
    {
      super(new HttpFile(s), v);
      System.out.println("Made file with string "+s);
    }
    public File getSelectedFile()
    {
//      return fixFile(super.getSelectedFile());
      return super.getSelectedFile();
    }
    public void setSelectedFile( File f)
    {
//      super.setSelectedFile(fixFile(f));
      super.setSelectedFile(f);
    }
    public  File[] getSelectedFiles() {return fixFiles(super.getSelectedFiles());}
    public void setSelectedFiles( File[] fs) {super.setSelectedFiles(fixFiles(fs));}
    public  File getCurrentDirectory()
    {
      return super.getCurrentDirectory();
//      return fixFile(super.getCurrentDirectory());
    }
    public void setCurrentDirectory( File f)
    {
      System.out.println("setCurrentDirectory("+f.getAbsolutePath()+")");
      System.out.println("f: "+f);
      System.out.println("class: "+f.getClass());
      super.setCurrentDirectory(f);
    }
    public void ensureFileIsVisible( File f) {super.ensureFileIsVisible(fixFile(f));}
    public  String getName( File f)
    {
      return super.getName(f);
//      return super.getName(fixFile(f));
    }
    public  String getDescription( File f) {return super.getDescription(fixFile(f));}
    public  String getTypeDescription( File f) {return super.getTypeDescription(fixFile(f));}
    public  Icon getIcon( File f)
    {
//      System.out.println("getIcon("+f+")");
//      System.out.println(super.getIcon(f));
//      return super.getIcon(fixFile(f));
      return super.getIcon(f);
    }
    public boolean isTraversable( File f)
    {
System.out.println("isTraversable("+f+")");
System.out.println("returning "+f.isDirectory());
      return f.isDirectory();
//      return true;
//      return super.isTraversable(fixFile(f));
    }
    public boolean accept( File f)
    {
      return super.accept(f);
//      return super.accept(fixFile(f));
    }

    public void setFileSystemView(FileSystemView fsv)
    {
      System.out.println(">");
      super.setFileSystemView(fsv);
      System.out.println("<");
    }
}
