package momoko.vfs;

import momoko.*;
import java.io.*;
import java.net.*;
import java.util.*;
import JSX.*;

public class ObjectDirectory extends ObjectFile
{
    static public boolean debug=false;
    private String path;
    private String name;
    private Vector subdir;
    protected IMObject obj;

    static public void main(String[] args)
    {
      unitTest();
    }

    static public void unitTest()
    {
      ObjectDirectory f=new ObjectDirectory("/world");
      print("", f);
    }

    static public void print(String prefix, ObjectDirectory f)
    {
      if(debug) System.out.println(prefix+f.getName());
      String[] sub=f.list();
      if(sub==null) return;
      for(int x=0;x<sub.length;x++)
        print(prefix+" ", new ObjectDirectory(f, sub[x]));
    }

    public ObjectDirectory(IMObject obj)
    {
      this(obj.getName());
      this.obj=obj;
      if(debug) System.out.println("exitting constructor");
    }

    public ObjectDirectory(ObjectDirectory parent, String child)
    {
      super(parent, child);
if(debug) System.out.println("ObjectDirectory(ObjectDirectory, String)");
      path=parent.getAbsolutePath()+"/"+child;
      name=path;
if(debug) System.out.println("set path: "+path);
      initialize();
    }

    public ObjectDirectory(String path)
    {
      super(path);
if(debug) System.out.println("ObjectDirectory("+path+")");
      this.path=path;
      name=path;
if(debug) System.out.println("Before init: "+name);
      initialize();
      if(debug) System.out.println("Hello my path is "+path);
    }

    public ObjectDirectory(String parent, String child)
    {
      super(parent, child);
if(debug) System.out.println("ObjectDirectory(String, String)");
      path=parent+"/"+child;
      name=path;
if(debug) System.out.println("set path: "+path);
      initialize();
    }

    public InputStream getInputStream()
    {
try
{
      File f=File.createTempFile("ObjectDirectory", ".lst");
      if(debug) System.out.println("f: "+f);
      FileOutputStream fos=new FileOutputStream(f);
      PrintWriter pw=new PrintWriter(fos);
      if(debug) System.out.println("fos: "+fos);
      Iterator iterator=obj.contents().keySet().iterator();
      pw.println("_self");
      while(iterator.hasNext())
        pw.println(iterator.next());
      pw.flush();
      pw.close();
      fos.close();
      FileInputStream fis=new FileInputStream(f);
      return fis;
}
catch(Exception e)
{
  e.printStackTrace();
  return null;
}
    }

    public OutputStream getOutputStream()
    {
      return null;
    }

    protected void initialize()
    {
    }

    public  String getName() {return name;}
    public  String getParent() {return null;}
    public  File getParentFile() {return null;}
    public  String getPath() {return path;}
    public boolean isAbsolute() {return false;}
    public  String getAbsolutePath() {return path;}
    public  File getAbsoluteFile() {return this;}

    public  String getCanonicalPath() throws  IOException
    {
if(debug) System.out.println("getCanonicalPath()");
if(debug) System.out.println("returning "+path);
      return path;
    }

    public  File getCanonicalFile() throws  IOException
    {
      return this;
    }

    public  URL toURL() throws  MalformedURLException
    {
      return null;
    }

    public boolean canRead() { return true; }
    public boolean canWrite() { return true; }
    public boolean exists() { return true; }
    public boolean isDirectory() { return true; }
    public boolean isFile() { return false; }
    public boolean isHidden() { return false; }
    public long lastModified() { return 0; }
    public long length() { return 0; }
    public boolean createNewFile() {return false;}
    public boolean delete() {return false;}
    public void deleteOnExit() {}
    public  String[] list()
    {
      String[] sarr=new String[obj.contents().size()+1];
      int x=1;
      Iterator iterator=obj.contents().keySet().iterator();
      while(iterator.hasNext())
      {
        sarr[x]=(String)iterator.next();
        x=x+1;
      }
      sarr[0]="_self";
      return sarr;    
    }
    public  String[] list( FilenameFilter f) { return null; }
    public  File[] listFiles()
    {
      String[] names=list();
      if(names==null) return null;
      File[] files = new File[names.length];
      for(int x=0;x<files.length;x++)
        if(names[x].equals("_self"))
          files[x]=new ObjectFile(this, names[x]);
        else
          files[x]=new ObjectDirectory(this, names[x]);
      return files;
    }
    public  File[] listFiles( FilenameFilter f) {return null;}
    public  File[] listFiles( FileFilter f) {return null;}
    public boolean mkdir() {return false;}
    public boolean mkdirs() { return false;}
    public boolean renameTo( File f) {return false;}
    public boolean setLastModified(long l) {return false;}
    public boolean setReadOnly() {return false;}
/*    public String toString()
    {
      if(debug) System.out.println("toString()");
      if(debug) System.out.println("path: "+path);
      if(debug) System.out.println(super.toString());
      return super.toString();
    }
*/
}
