package momoko.webserver;

import momoko.compiler.Compiler;
import java.util.*;
import momoko.*;
import momoko.types.*;
import momoko.stream.*;
import momoko.server.*;
import momoko.util.*;
import java.lang.reflect.*;
import java.io.*;
import momoko.vfs.*;

public class HttpFileViewServer extends CommandInterpreter implements FileServer
{
  public static String url="http://"+Database.main.getHostname()+":8080/";
  ClassLoader loader;

  public HttpFileViewServer()
  {
    super();
    h.put("GET", new get());
    h.put("PUT", new put());
  }

  public String getURL()
  {
    return url;
  }

  public void setLoader(ClassLoader l)
  {
    loader=l;
  }

private class get implements Command
{
  public void execute(String[] command, CommandInterpreter interp)
    {
      String url=command[1];
      System.out.println("original url: "+url);
      int i=url.lastIndexOf('/');
      String filename=url.substring(i+1);
      boolean dir=true;
      if(filename.equals("_self"))
      {
        dir=false;
System.out.println("broken url: "+url);
        url=url.substring(0, i);
      }
      System.out.println("getting URL "+url+" ("+dir+")");      
      InputStream headin=handler.getInputStream();
      BufferedReader br=new BufferedReader(new InputStreamReader(headin));
try{
      String s=br.readLine();
      while(!s.equals("")) s=br.readLine();
}
catch(Exception e) {e.printStackTrace();}
      PrintWriter pw=new PrintWriter(handler.getOutputStream());
      InputStream in=null;
      try
      {
        IMObject obj;
System.out.println("Final url: "+url);
        if(url.equals("/") || url.equals(""))
          obj=Database.main.root;
        else
          obj=Database.main.root.resolve(url);
        System.out.println("obj: "+obj);
        VirtualFile file;
        if(dir)
          file = obj.getDirectoryView();
        else
          file = obj.getFileView();
        System.out.println("file: "+file);
        if(file==null) throw new BadPathException("File view not available");
        in=file.getInputStream();
        System.out.println("in: "+in);
      }
      catch(Exception e) { e.printStackTrace(); }

      if(in==null)
      {
        handler.format("HTTP/1.1 404 Not Found");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
      }
      else
      {
        handler.format("HTTP/1.1 200 OK");
        handler.format("Connection: close");
        System.out.println("dir: "+dir);
        if(dir)
          handler.format("Content-type: text/directory");
        else
          handler.format("Content-type: application/unknown");
        handler.format("");
        OutputStream out=handler.getOutputStream();
        Conduit c=new Conduit(in, out);
        c.run();
      }
      interp.close();
    }
}

private class put implements Command
{
  public void execute(String[] command, CommandInterpreter interp)
  {
      String url=command[1];
      while(url.startsWith("/"))
        url=url.substring(1);
      if(url.equals(""))
        url=".";
      System.out.println("putting URL "+url);      
      int len=0;
      InputStream headin=handler.getInputStream();
      BufferedReader br=new BufferedReader(new InputStreamReader(headin));
      try
      {
        String s=br.readLine();
        while(!s.equals(""))
        {
          System.out.println(s);
          if(s.startsWith("Content-Length: ") || s.startsWith("Content-length: "))
          {
            System.out.println("Length!");
            Vector v=StringUtils.split(s, " ");
            System.out.println("v: "+v);
            len = Integer.parseInt((String)v.elementAt(1));
            System.out.println("len: "+len);
          }
          s=br.readLine();
        }
        PrintWriter pw=new PrintWriter(handler.getOutputStream());
        InputStream in=null;
        File f=new File(url);
        FileOutputStream fos=new FileOutputStream(f);
        for(int x=0;x<len;x++)
          fos.write(br.read());
        System.out.println("done");
      }
      catch(IOException e)
      {
        e.printStackTrace();
        handler.format("HTTP/1.1 404 Not Found");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
        interp.close();
        return;
      }

      handler.format("HTTP/1.1 200 OK");
      handler.format("Connection: close");
      handler.format("Content-type: application/unknown");
      handler.format("");
      handler.format("");
      interp.close();
      return;
   }
 }

}
