package momoko.webserver;

import momoko.compiler.Compiler;
import java.util.*;
import momoko.*;
import momoko.types.*;
import momoko.server.*;
import java.lang.reflect.*;
import java.io.*;
import momoko.stream.*;
import momoko.util.*;

public class HttpInterpreter extends CommandInterpreter implements FileServer
{
  public static String url="http://"+Database.main.getHostname()+":8080/";
  ClassLoader loader;

  public HttpInterpreter()
  {
    super();
    h.put("GET", new get());
    h.put("PUT", new put());
System.out.println("Http Interpreter linking to class loader");
    Database.main.loader.setServer(this);
  }

  public String getURL()
  {
    return url;
  }

  public void setLoader(ClassLoader l)
  {
    loader=l;
  }

private class get implements Command
{
  public void execute(String[] command, CommandInterpreter interp)
    {
      String url=command[1];
      while(url.startsWith("/"))
        url=url.substring(1);
      if(url.equals(""))
        url=".";
      System.out.println("getting URL "+url);      
      System.out.println(loader);
      InputStream headin=handler.getInputStream();
      BufferedReader br=new BufferedReader(new InputStreamReader(headin));
try{
      String s=br.readLine();
      while(!s.equals("")) s=br.readLine();
}
catch(Exception e) {e.printStackTrace();}
      PrintWriter pw=new PrintWriter(handler.getOutputStream());
      InputStream in=null;
      in=loader.getResourceAsStream(url);
      File f=new File(url);
      if(f.exists())
      {
        if(f.isDirectory())
        {
        pw.print("HTTP/1.1 200 OK\015\012");
pw.println("Date: Wed, 31 Jan 2001 03:25:54 GMT");
pw.println("Server: Apache/1.3.9 (Unix) Debian/GNU");
pw.println("Last-Modified: Fri, 26 Jan 2001 01:30:30 GMT");
pw.println("ETag: \"c8034-10-3a70d336\"");
pw.println("Accept-Ranges: bytes");
//pw.println("Content-Length: 16");
pw.println("Connection: close");
pw.println("Content-Type: text/directory; charset=iso-8859-1");
        pw.println();
        String[] list=f.list();
        for(int x=0;x<list.length;x++)
          pw.println(list[x]);
        pw.flush();
        pw.close();
        interp.close();
        return;
        }
        else
          try { in=new FileInputStream(f); }
          catch(Exception e) {e.printStackTrace();}
      }
      System.out.println(in);
      if(in==null)
      {
        handler.format("HTTP/1.1 404 Not Found");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
      }
      else
      {
        handler.format("HTTP/1.1 200 OK");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
        OutputStream out=handler.getOutputStream();
        Conduit c=new Conduit(in, out);
        c.run();
      }
      interp.close();
    }
}

private class put implements Command
{
  public void execute(String[] command, CommandInterpreter interp)
  {
      String url=command[1];
      while(url.startsWith("/"))
        url=url.substring(1);
      if(url.equals(""))
        url=".";
      System.out.println("putting URL "+url);      
      int len=0;
      InputStream headin=handler.getInputStream();
      BufferedReader br=new BufferedReader(new InputStreamReader(headin));
      try
      {
        String s=br.readLine();
        while(!s.equals(""))
        {
          System.out.println(s);
          if(s.startsWith("Content-Length: ") || s.startsWith("Content-length: "))
          {
            System.out.println("Length!");
            Vector v=StringUtils.split(s, " ");
            System.out.println("v: "+v);
            len = Integer.parseInt((String)v.elementAt(1));
            System.out.println("len: "+len);
          }
          s=br.readLine();
        }
        PrintWriter pw=new PrintWriter(handler.getOutputStream());
        InputStream in=null;
        File f=new File(url);
        System.out.println("writing to file "+f.getAbsolutePath());
        FileOutputStream fos=new FileOutputStream(f);
        for(int x=0;x<len;x++)
          fos.write(br.read());
        System.out.println("done");
      }
      catch(IOException e)
      {
        e.printStackTrace();
        handler.format("HTTP/1.1 404 Not Found");
        handler.format("Connection: close");
        handler.format("Content-type: application/unknown");
        handler.format("");
        interp.close();
        return;
      }

      handler.format("HTTP/1.1 200 OK");
      handler.format("Connection: close");
      handler.format("Content-type: application/unknown");
      handler.format("");
      handler.format("");
      interp.close();
      return;
   }
 }

}
